package cat.hack3.codingtests.marsrover.cartography;

public record Coordinates(Latitude latitude, Longitude longitude) {

    public static Coordinates of(long latitude, long longitude) {
        return new Coordinates(new Latitude(latitude), new Longitude(longitude));
    }

    public Coordinates ofUpdatedLatitude(long newLatitude) {
        return Coordinates.of(newLatitude, longitude.pointer);
    }

    public Coordinates ofUpdatedLongitude(long newLongitude) {
        return Coordinates.of(latitude.pointer, newLongitude);
    }

    record Latitude(long pointer) {
        @Override
        public String toString() {
            return String.valueOf(pointer);
        }
    }
    record Longitude(long pointer) {
        @Override
        public String toString() {
            return String.valueOf(pointer);
        }
    }

}
